struct VertexInput
{
    float4 myPosition : POSITION;
    float4 myNormal : NORMAL;
    float4 myTangent : TANGENT;
    float4 myBinormal : BINORMAL;
    float2 myUV : TEXCOORD;
    float4 myColor : COLOR;
};

struct VertexInputAnimation
{
    float4 myPosition : POSITION;
    float4 myNormal : NORMAL;
    float4 myTangent : TANGENT;
    float4 myBinormal : BINORMAL;
    float2 myUV : TEXCOORD;

	float4 myBoneIDs : BONES;
	float4 myBoneWeights : WEIGHTS;
};

struct VertexToPixel
{
    float4 myPosition : SV_POSITION;
    float4 myWorldPosition : WORLDPOS;
    float4 myNormal : NORMAL;
    float4 myTangent : TANGENT;
    float4 myBinormal : BINORMAL;
    float2 myUV : TEXCOORD0;
    float4 myColor : COLOR;
};

struct VertexToHull
{
    float4 myWorldPosition : WORLDPOS;
    float4 myNormal : NORMAL;
    float4 myTangent : TANGENT;
    float4 myBinormal : BINORMAL;
    float2 myUV : TEXCOORD0;
    float4 myColor : COLOR;
};

struct PixelOutput
{
    float4 myColor : SV_TARGET;
};

struct HullOut
{
    float3 myWorldPosition : WORLDPOS;
    float3 myNormal : NORMAL;
    float3 myTangent : TANGENT;
    float3 myBinormal : BINORMAL;
    float2 myUV : TEXCOORD;
    float4 myColor : COLOR;
};

struct TriTess
{
    float Edges[3] : SV_TessFactor;
    float Inside : SV_InsideTessFactor;
};