struct VertexInput
{
	float4 myPosition : POSITION;
    float4 myVelocity : VELOCITY;
	float4 myColor : COLOR;
    float2 mySize : SIZE;
    float myLifeTime : LIFETIME;
    float myInitialLifeTime : INITIAL_LIFETIME;
    float myDistanceToCamera : CAMERA_DISTANCE;
    float myRotation : ROTATION;
    float myRandom : RANDOM;
    float3 myParentPosition : PARENT_POSITION;
    float3 myParentSize : PARENT_SIZE;
    float4 myParentRotation : PARENT_ROTATION;
};

struct VertexToGeometry
{
    float4 myPosition : POSITION;
    float4 myColor : COLOR;
    float2 mySize : SIZE;
    float myQuadRotation : ROTATION;
    float4 myWorldRotation : PARENT_ROTATION;
    float myLifeTime : LIFETIME;
    float myInitialLifeTime : INITIAL_LIFETIME;
    float myRandom : RANDOM;
};

struct GeometryToPixel
{
	float4 myPosition : SV_POSITION;
	float4 myColor : COLOR;
	float2 myUV : UV;
    float myLifeTime : LIFETIME;
    float myInitialLifeTime : INITIAL_LIFETIME;
    float myRandom : RANDOM;
};

struct PixelOutput
{
	float4 myColor : SV_TARGET;
};