cbuffer ObjectBuffer : register(b1)
{
    float4 myScreenSpacePosition;
    float4 myColor;
    float4 myUV;
    float2 mySize;
    float myRotation;
}

struct VertexInput
{
	float4 myPosition : POSITION;
    float2 mySize: SIZE;
    float4 myUV: UV;
};

struct VertexToGeometry
{
    float3x3 myTransformMatrix : TRANSFORM;
    float3 myPosition : POSITION;
    float4 myUV : UV;
};

struct GeometryToPixel
{
    float4 myPosition : SV_POSITION;
    float2 myUV : UV;
};

struct PixelOutput
{
    float4 myColor : SV_TARGET;
};
