#include "..\Globals.hlsli"
#include "..\ParticleShaderStructs.hlsli"

static const float2 offset[4] =
{
    { -0.5f, 0.5f },
    { 0.5f, 0.5f },
    { -0.5f, -0.5f },
    { 0.5f, -0.5f }
};

static const float2 uv[4] =
{
    { 0.0f, 0.0f },
    { 1.0f, 0.0f },
    { 0.0f, 1.0f },
    { 1.0f, 1.0f }
};

[MaxVertexCount(4)]
void main(point VertexToGeometry input[1], inout TriangleStream<GeometryToPixel> output)
{
    VertexToGeometry inputvertex = input[0];
    float c = cos(inputvertex.myQuadRotation);
    float s = sin(inputvertex.myQuadRotation);
    float3x3 rotation =
    {
        c, s, 0,
        -s, c, 0,
        0, 0, 1
    };
	float4x4 r=
	{
		1, 0, 0, 0,
		0, 1, 0, 0,
		0, 0, 1, 0,
		0, 0, 0, 1
	};
    for (uint index = 0; index < 4; ++index)
    {
        GeometryToPixel vertex;
        vertex.myPosition = inputvertex.myPosition;
        float3 pos = float3(offset[index] * inputvertex.mySize, 0);
        pos = mul(rotation, pos);
        vertex.myPosition.xy += pos.xy;
       vertex.myPosition = mul(toProjection, vertex.myPosition);
        vertex.myColor = inputvertex.myColor;
        vertex.myUV = uv[index];
        vertex.myRandom = inputvertex.myRandom;
        vertex.myLifeTime = inputvertex.myLifeTime;
        vertex.myInitialLifeTime = inputvertex.myInitialLifeTime;
        output.Append(vertex);
    }
}