#include "..\Globals.hlsli"
#include "..\QuadShaderStructs.hlsli"

cbuffer QuadBuffer : register(b1)
{
    float4x4 toWorld;
    float4 myColor;
    float4 myUV;
}

static const float2 offset[4] =
{
    { -0.5f, 0.5f },
    { 0.5f, 0.5f },
    { -0.5f, -0.5f },
    { 0.5f, -0.5f }
};

static const uint2 uvIndex[4] =
{
    { 0, 1 },
    { 2, 1 },
    { 0, 3 },
    { 2, 3 }
};

[MaxVertexCount(4)]
void main(point VertexToGeometry input[1], inout TriangleStream<GeometryToPixel> output)
{
    for (uint index = 0; index < 4; ++index)
    {
        float4 objectPos = float4(offset[index], 0, 1);
        float4 worldPos = mul(toWorld, objectPos);
        float4 viewPos = mul(toCamera, worldPos);
        float4 projectionPos = mul(toProjection, viewPos);

        GeometryToPixel vertex;
        vertex.myPosition = projectionPos;
        vertex.myColor = myColor;
        vertex.myUV = float2(myUV[uvIndex[index].x], myUV[uvIndex[index].y]);

        output.Append(vertex);
    }
}