#include "..\Globals.hlsli"
#include "..\SpriteShaderStructs.hlsli"

static const float2 offset[4] =
{
    { -0.5f, 0.5f },
    { 0.5f, 0.5f },
    { -0.5f, -0.5f },
    { 0.5f, -0.5f }
};

static const uint2 uvIndex[4] =
{
    { 0, 1 },
    { 2, 1 },
    { 0, 3 },
    { 2, 3 }
};

[MaxVertexCount(4)]
void main(point VertexToGeometry input[1], inout TriangleStream<GeometryToPixel> output)
{
    VertexToGeometry inputVertex = input[0];
    for (uint index = 0; index < 4; ++index)
    {
        float2 vertexOffset = offset[index];
        vertexOffset = mul(float3(vertexOffset, 1.0f), inputVertex.myTransformMatrix).xy;

        GeometryToPixel vertex;
        vertex.myPosition.xy = PixelSpaceToScreenSpace(vertexOffset + inputVertex.myPosition.xy);
        vertex.myPosition.z = saturate(inputVertex.myPosition.z);
        vertex.myPosition.w = 1.0f;
        vertex.myUV = float2(inputVertex.myUV[uvIndex[index].x], inputVertex.myUV[uvIndex[index].y]);
        output.Append(vertex);
    }
}