#include "..\Globals.hlsli"
#include "..\TextWorldShaderStructs.hlsli"

static const float2 offset[4] =
{
    { 0.0f, 1.0f },
    { 1.0f, 1.0f },
    { 0.0f, 0.0f },
    { 1.0f, 0.0f }
};

static const uint2 uvIndex[4] =
{
    { 0, 1 },
    { 2, 1 },
    { 0, 3 },
    { 2, 3 }
};

[MaxVertexCount(4)]
void main(point VertexToGeometry input[1], inout TriangleStream<GeometryToPixel> output)
{
    VertexToGeometry inputVertex = input[0];

    float3x3 rotation = (float3x3) myTransform;

    for (uint index = 0; index < 4; ++index)
    {
        //float3 cornerOffset = mul(rotation, float3(offset[index] * inputVertex.mySize, 0));
        float4 objectPos = inputVertex.myPosition + float4(offset[index] * inputVertex.mySize, 0, 0);
        float4 worldPos = mul(myTransform, objectPos);
        float4 viewPos = mul(toCamera, worldPos);
        float4 projectionPos = mul(toProjection, viewPos);

        GeometryToPixel vertex;
        vertex.myPosition = projectionPos;
        vertex.myUV = float2(inputVertex.myUV[uvIndex[index].x], inputVertex.myUV[uvIndex[index].y]);

        output.Append(vertex);
    }
}