#include "../ModelShaderStructs.hlsli"

[domain("tri")]
[partitioning("fractional_odd")]
[outputtopology("triangle_cw")]
[outputcontrolpoints(3)]
[patchconstantfunc("ConstantHS")]
[maxtessfactor(32.0)]
HullOut HS(InputPatch<VertexToHull, 3> inputPatch, uint uCPID : SV_OutputControlPointID)
{
    HullOut Out; // Copy inputs to outputs pass through shaders are optimal
    Out.myWorldPosition = inputPatch[uCPID].myWorldPosition.xyz;
    Out.myUV = inputPatch[uCPID].myUV;
    Out.myNormal = inputPatch[uCPID].myNormal.xyz;
    Out.myTangent = inputPatch[uCPID].myTangent.xyz;
    Out.myBinormal = inputPatch[uCPID].myBinormal.xyz;
    Out.myColor = inputPatch[uCPID].myColor;
    return Out;
}

TriTess ConstantHS(InputPatch<VertexToHull, 3> p, uint PatchID : SV_PrimitiveID)
{
    TriTess Out;
    // Assign tessellation factors in this case use a global
    // tessellation factor for all edges and the inside. These are
    // constant for the whole mesh.
    Out.Edges[0] = 32.0;
    Out.Edges[1] = 32.0;
    Out.Edges[2] = 32.0;
    Out.Inside   = Out.Edges[0];
    return Out;
}