#include "..\Globals.hlsli"
#include "..\ParticleShaderStructs.hlsli"

cbuffer ParticleBuffer : register(b2)
{
    uint2 myRowsCols;
    float myAnimFPS;
}

Texture2D tex : register(t0);

PixelOutput main(GeometryToPixel input)
{
    PixelOutput result;
    
    int index = (input.myInitialLifeTime - input.myLifeTime) * myAnimFPS;

    float2 frameSize = 1.0f / myRowsCols;
    int row = index % myRowsCols.x;
    int col = floor((index % (myRowsCols.x * myRowsCols.y)) / myRowsCols.y);
    float u = input.myUV.x / myRowsCols.x + row * frameSize;
    float v = input.myUV.y / myRowsCols.y + col * frameSize;
    result.myColor = tex.Sample(defaultClampSampler, float2(u, v)) * input.myColor;
    return result;
}