#include "..\Globals.hlsli"
#include "..\GBufferInput.hlsli"

Texture2D texture0 : register(t20);

PixelOutput main(VertexToPixel input)
{
	//float2 offset = float2(.001, .0); //Amount of Cromatic
	//Color.r = texture0.Sample(defaultSampler, input.myUV + offset.xy).r;							  //old
	//Color.g = texture0.Sample(defaultSampler, input.myUV).g;										  //old
	//Color.b = texture0.Sample(defaultSampler, input.myUV + offset.yx).b;							  //old
	//Color.a = 1.0;
	//
    
	
	PixelOutput output;
	float4 Color;
    float3 refractiveIndex = float3(1.0, 1.005, 1.003);
	
	float2 normalizedTexCoord = float2(2.0, 2.0) * input.myUV - float2(1.0, 1.0);    // [0, 1] -> [-1, 1]
	float3 texVec = float3(normalizedTexCoord, 1.0);
	float3 normalVec = float3(0.0, 0.0, -1.0);
	float3 redRefractionVec = refract(texVec, normalVec, refractiveIndex.r);
	float3 greenRefractionVec = refract(texVec, normalVec, refractiveIndex.g);
	float3 blueRefractionVec = refract(texVec, normalVec, refractiveIndex.b);
	float2 redTexCoord = ((redRefractionVec / redRefractionVec.z).xy + float2(1.0, 1.0)) / float2(2.0, 2.0);
	float2 greenTexCoord = ((greenRefractionVec / greenRefractionVec.z).xy + float2(1.0, 1.0)) / float2(2.0, 2.0);
	float2 blueTexCoord = ((blueRefractionVec / blueRefractionVec.z).xy + float2(1.0, 1.0)) / float2(2.0, 2.0);


    Color.r = texture0.Sample(defaultClampSampler, redTexCoord).r;
    Color.g = texture0.Sample(defaultClampSampler, greenTexCoord).g;
    Color.b = texture0.Sample(defaultClampSampler, blueTexCoord).b;
	Color.a = 1.0;

    //Color.rgb *= playerSpeed/ 120;

    output.myColor = Color;
	return output;
}