#include "..\Globals.hlsli"
#include "..\GBufferInput.hlsli"

Texture2D texture0 : register(t20);

PixelOutput main(VertexToPixel input)
{
    const int nsamples = 10;


    float2 center = float2(0.5, 0.5);
    float blurStart = 1.0;
    float blurWidth = abs(0 + 0.02/* * saturate(playerCurrentSpeed / playerBaseSpeed - 1.0f)*/); // this is the value we want to change from engine ! 


    input.myUV -= center;
    float precompute = blurWidth * (1.0 / float(nsamples - 1));

    float4 color = float(0.0);
    for (int i = 0; i < nsamples; i++)
    {
        float scale = blurStart + (float(i) * precompute);
		//	color += texture(iChannel0, uv * scale + center);
        color += texture0.Sample(defaultClampSampler, input.myUV * scale + center);
    }


    color /= float(nsamples);
    PixelOutput output;
    output.myColor = color; // float(nsamples);
    return output;
}