#include "..\Globals.hlsli"
#include "..\GBufferInput.hlsli"

Texture2D texture0 : register(t10);



// Sepia Color
const float3 SEPIA = float3(1.25, 1.0, 0.85);
PixelOutput main(VertexToPixel input)
{
	PixelOutput output;
	float4 Color;
	float2 uv = input.myUV;
	uv.y += (cos((uv.y + (totalTime * 0.08)) * 45.0) * 0.0019) +
		(cos((uv.y + (totalTime * 0.1)) * 10.0) * 0.002);

	uv.x += (sin((uv.y + (totalTime * 0.07)) * 20.0) * 0.0029) +
		(sin((uv.y + (totalTime * 0.1)) * 15.0) * 0.002);
	float3 refractiveIndex = float3(1.0, 1.005, 1.003);

	float2 normalizedTexCoord = float2(2.0, 2.0) * uv - float2(1.0, 1.0);    // [0, 1] -> [-1, 1]
	float3 texVec = float3(normalizedTexCoord, 1.0);
	float3 normalVec = float3(0.0, 0.0, -1.0);
	float3 redRefractionVec = refract(texVec, normalVec, refractiveIndex.r);
	float3 greenRefractionVec = refract(texVec, normalVec, refractiveIndex.g);
	float3 blueRefractionVec = refract(texVec, normalVec, refractiveIndex.b);
	float2 redTexCoord = ((redRefractionVec / redRefractionVec.z).xy + float2(1.0, 1.0)) / float2(2.0, 2.0);
	float2 greenTexCoord = ((greenRefractionVec / greenRefractionVec.z).xy + float2(1.0, 1.0)) / float2(2.0, 2.0);
	float2 blueTexCoord = ((blueRefractionVec / blueRefractionVec.z).xy + float2(1.0, 1.0)) / float2(2.0, 2.0);


	Color.r = texture0.Sample(defaultClampSampler, redTexCoord).r*7;
	Color.g = texture0.Sample(defaultClampSampler, greenTexCoord).g*7;
	Color.b = texture0.Sample(defaultClampSampler, blueTexCoord).b*7;
	Color.a = 1.0;
	const int nsamples = 10;


	float2 center = float2(0.5, 0.5);
	float blurStart = 1.0;
	float blurWidth = abs(0 + 0.05); /* * saturate(playerCurrentSpeed / playerBaseSpeed - 1.0f)*/// this is the value we want to change from engine ! 
	float4 newcol = texture0.Sample(defaultClampSampler, uv);


	uv -= center;
	float precompute = blurWidth * (1.0 / float(nsamples - 1));

	for (int i = 0; i < nsamples; i++)
	{
		float scale = blurStart + (float(i) * precompute);
		//	color += texture(iChannel0, uv * scale + center);
		Color += texture0.Sample(defaultClampSampler, uv * scale + center);
	}
	Color /= float(nsamples);


	float Grey = dot(Color, float3(0.5, 0.79, 0.91)) ;
	float3 sepiaColor = float(Grey);

	output.myColor.rgb = texture0.Sample(defaultClampSampler, input.myUV);
    output.myColor.rgb += lerp(Color.rgb, sepiaColor, 0.25); //* //playerSpiritWalkFade;

	
	//
	return output;

}
