#include "..\Globals.hlsli"
#include "..\GBufferInput.hlsli"
#include "..\h_gaussian_kernels.hlsli"

Texture2D texture0 : register(t20);

PixelOutput main(VertexToPixel input)
{
    float texelSize = 1.0f / (screenHeight / 1);
    float3 pixelColor = float3(0.0f, 0.0f, 0.0f);

    uint kernelSize = 11;
    float start = (((float) (kernelSize) - 1.0f) / 2.0f) * -1.0f;
    for (uint index = 0; index < kernelSize; ++index)
    {
        float2 uv = input.myUV + float2(0.0f, texelSize * (start + index));
        float3 texColor = texture0.Sample(defaultClampSampler, uv).rgb;
        pixelColor += texColor * kernel11[index];
    }

    PixelOutput output;
    output.myColor = float4(pixelColor, 1.0f);
    return output;
}