#include "..\Globals.hlsli"
#include "..\SpriteShaderStructs.hlsli"

Texture2D tex : register(t0);

PixelOutput main(GeometryToPixel input)
{

	float d = length(input.myUV);
	float z = sqrt(2 - d * d);
	float r = atan2(d, z) / 3.14159;
	float phi = atan2(input.myUV.y, input.myUV.x);

	float2 animUV =	 float2(r*cos(phi) + 500.5, r*sin(phi) + 500.5);
	float2 animUV2 = float2(r*cos(phi) + 50.5, r*sin(phi) + 500.5);

	animUV.x += (totalTime/300);
	animUV.y -= totalTime/(100+abs(sin(50)));
	animUV.x = animUV.x * 3;
	animUV.y = animUV.y;

	animUV2.x += -(totalTime / 300);
	animUV2.y -= totalTime / (100 + abs(sin(50)));
	animUV2.x = animUV2.x * 8;
	animUV2.y = animUV2.y*1;
	float4 rand = randomTexture.Sample(defaultWrapSampler, animUV).r;
	float4 rand2 = randomTexture.Sample(defaultWrapSampler, animUV2).r;
	rand = rand * rand2;
	float4 clearColor = float4(0.25f, 0.35f, 0.35f, 0.35);
	float4 healthColor = float4(1, 0.0, 0, 1);
	healthColor.rgb = healthColor.rgb*(rand*3.2);
    float health = 0; //playerHealthPercentage;
	health = abs(1 - health);
	float2 uv = input.myUV;
//	uv.y += health *totalTime;
	uv.y += sin(input.myUV.x * 100 + totalTime) / (40+(sin(totalTime)*20));//+abs(sin(20*totalTime/500));
	float2 uv2 = input.myUV;
	uv2.y += sin(input.myUV.x * 100 + totalTime + 0.4) / (40 + (sin(totalTime) * 20));
	float healthMask = step(uv.y, health);
	float healthMask2 = step(uv2.y, health - 0.04f);
	PixelOutput result;

	float4 reflection = 1 - tex.Sample(defaultClampSampler, input.myUV).rgba;
	float mask = 1 - reflection.a;
	reflection.a = length(reflection.rgb);
	float4 albedo = lerp(healthColor, clearColor, healthMask);
	
	float4 topColor = lerp(float4(0.5, 0.1, 0.1, 0.95), clearColor, healthMask2);
	albedo = lerp(albedo, topColor, healthMask);
	
	topColor.rgb = mask * (topColor.rgb + pow(reflection.rgb, 0.5) * 0.3);
	result.myColor.rgb = mask * (albedo.rgb + pow(reflection.rgb, 0.5) * 0.3);
	result.myColor.a = mask * albedo.a;
	return result;
}