#include "..\Globals.hlsli"
#include "..\SpriteShaderStructs.hlsli"

Texture2D tex : register(t0);

PixelOutput main(GeometryToPixel input)
{


	float d = length(input.myUV);
	float z = sqrt(2 - d * d);
	float r = atan2(d, z) / 3.14159;
	float phi = atan2(input.myUV.y, input.myUV.x);

	float2 animUV = float2(r*cos(phi) + .5, r*sin(phi) + .5);
	float2 animUV2 = float2(r*cos(phi) + 0.5, r*sin(phi) + .5);

	animUV.x += (totalTime / 300);
	animUV.y -= totalTime / (100 + abs(sin(50)));
	animUV.x = animUV.x * 5;
	animUV.y = animUV.y;

	animUV2.x += -(totalTime / 300);
	animUV2.y -= totalTime / (100 + abs(sin(50)));
	animUV2.x = animUV2.x * 8;
	animUV2.y = animUV2.y * 1;
	float4 rand = randomTexture.Sample(defaultWrapSampler, animUV).r;
	//rand.r = 1;// = rand.rgb * float4(1, 1, 1, 1);
	float4 rand2 = randomTexture.Sample(defaultWrapSampler, animUV2).r;
	rand = (rand * rand2)*2;
	float4 extraWave = rand;
	float4 clearColor = float4(0.3f, 0.3f, 0.3f, 0.1f);
	float test = 1-sin(totalTime)*0.1;
	float4 HealthColor = float4(0.8, 0.8, 0, 1)*(rand*2.34);

    float mana = 0;//playerManaPercentage;
	mana = abs(1 - mana);
	float2 uv = input.myUV;
	uv.y += sin(input.myUV.x * 100 + totalTime) / (40 + (sin(totalTime) * 20));//+abs(sin(20*totalTime/500));
	float2 uv2 = input.myUV;
	uv2.y += sin(input.myUV.x * 100 + totalTime+0.4) / (40 + (sin(totalTime) * 20));
	float healthMask = step(uv.y, mana);
	float healthMask2 = step(uv2.y, mana-0.04f);
	PixelOutput result;
	
	float4 reflection = 1 - tex.Sample(defaultClampSampler, input.myUV).rgba;
	float mask = 1 - reflection.a;
	reflection.a = length(reflection.rgb);

	float4 albedo = lerp(HealthColor, clearColor, healthMask);
	float4 topColor = lerp(float4(.7f,0.7,0,1), clearColor, healthMask2);
	albedo = lerp(albedo, topColor, healthMask);

	topColor.rgb = mask * (topColor.rgb + pow(reflection.rgb, 0.5) * 0.4);
	result.myColor.rgb = mask * (albedo.rgb + pow(reflection.rgb, 0.5) * 0.4);
	result.myColor.a = mask * albedo.r;
    return result;
}