#include "..\Globals.hlsli"
#include "..\GBufferInput.hlsli"

Texture2D texture0 : register(t20);

PixelOutput main(VertexToPixel input)
{
    float3 texColor = texture0.Sample(defaultClampSampler, input.myUV).rgb;

    PixelOutput output;
    //1
    //{
    //    float luminance = dot(texColor, float3(0.2126f, 0.7152f, 0.0722f));
    //    output.myColor.rgb = texColor * pow(luminance, 5);
    //}
    //2
    {
        float3 emiss = Emissive(input);


        float3 texNColor = normalize(texColor);
        float luminance = dot(texNColor, float3(0.2126f, 0.7152f, 0.0722f));
        float cutoff = 0.8f;
        if (luminance >= cutoff)
        {
            output.myColor.rgb = texColor + emiss;
        }
        else if (luminance >= cutoff * 0.5f)
        {
            float fade = luminance / cutoff;
            fade = pow(fade, 5);
            output.myColor.rgb = texColor * fade + emiss;
        }
        else
        {
            output.myColor.rgb = float3(0, 0, 0) + emiss;
        }
    }
    output.myColor.a = 1.0f;
    return output;
}