#include "..\Globals.hlsli"
#include "..\GBufferInput.hlsli"

Texture2D texture0 : register(t20); 

PixelOutput main(VertexToPixel input)
{
    PixelOutput output;
    float2 center = float2(0.5, 0.425);
    float4 texColor = texture0.Sample(defaultClampSampler, input.myUV);
    output.myColor = float4(texColor);
    
    const float InnerRadius = 0.01f;
    const float OuterRadius = 0.18f;
    float distance = length(center - input.myUV);
    float alpha = saturate((distance - InnerRadius) / (OuterRadius - InnerRadius));
    output.myColor.a *= alpha;
    //output.myColor.a *= length(center - input.myUV) * 2;
    return output;
}