#include "..\Globals.hlsli"
#include "..\ModelShaderStructs.hlsli"

cbuffer ObjectBuffer : register(b1)
{
    float4x4 toWorld;
}

VertexToPixel main(VertexInput input)
{
    VertexToPixel result;

    float4 objectPos = input.myPosition.xyzw;
    float4 worldPos = mul(toWorld, objectPos);
	float4 viewPos = mul(toCamera, worldPos);
    float4 projectionPos = mul(toProjection, viewPos);

    float3x3 toWorldRotation = (float3x3) toWorld;

    float3 normal = mul(toWorldRotation, input.myNormal.xyz);
    float3 tangent = mul(toWorldRotation, input.myTangent.xyz);
    float3 binormal = mul(toWorldRotation, input.myBinormal.xyz);

    result.myPosition = projectionPos;
    result.myWorldPosition = worldPos;
    result.myNormal = float4(normal, 0);
    result.myTangent = float4(tangent, 0);
    result.myBinormal = float4(binormal, 0);
    result.myColor = input.myColor;
    result.myUV = input.myUV;

    return result;
}