#include "..\Globals.hlsli"
#include "..\ModelShaderStructs.hlsli"

cbuffer ObjectBuffer : register(b1)
{
	float4x4 toWorld;
}

VertexToPixel main(VertexInput input)
{
//	float3 hardCODED = float3(12090,97, 8);

	VertexToPixel result;
	float wind = 0.3;
	float4 objectPos = input.myPosition.xyzw;
	float4 worldPos = mul(toWorld, objectPos);
	float4 viewPos = mul(toCamera, worldPos);
	float4 projectionPos = mul(toProjection, viewPos);

	float3x3 toWorldRotation = (float3x3) toWorld;
	float3 normal = mul(toWorldRotation, input.myNormal.xyz);
	float3 tangent = mul(toWorldRotation, input.myTangent.xyz);
	float3 binormal = mul(toWorldRotation, input.myBinormal.xyz);

	result.myPosition = projectionPos;
	result.myWorldPosition = worldPos;
	result.myNormal = float4(normal, 0);
	result.myTangent = float4(tangent, 0);
	result.myBinormal = float4(binormal, 0);
	result.myColor = input.myColor;
	result.myUV = input.myUV;
	//return result;
	float4 newPos = worldPos;
	float3  offset = float3(toWorld._14, toWorld._24, toWorld._34);
	
	float RADUIS = 100;
	float3 playerPos = cameraPos;
	playerPos = float3(cameraPos.x + 1180, cameraPos.y - 1840, cameraPos.z + 1610);
	float lenght =abs(1-length(playerPos -offset));
	float3 dir =  normalize(playerPos -offset);
	///////////////////////////
	float time = totalTime+( offset.x*0.08+ offset.z*0.08)*1.4;
	float freq = 2.5f;
	float CosInput = (time) * freq;

	float amp = 10.0f;
	float Cos = cos(CosInput);
	Cos *= amp;
	
	//newPos.x += Cos * (input.myColor.r);
	wind = sin(time*wind);
	float wind2 = sin(time +0.2*wind+offset.x);
	float wind3 = sin(time + 0.8*wind+ offset.x);


		//BEND
		//newPos.y += dir * lenght;
		float smooth = abs( RADUIS/lenght);
		newPos.z += (Cos * input.myColor.r)*wind*wind2*wind3;
		newPos.x += (Cos  * input.myColor.r)*wind*wind3;
		newPos.y += (Cos * input.myColor.r)*wind*1.3f;
		newPos.xyz -= input.myColor.r*((dir*25)*smooth);

	//newPos.xyz = mul(newPos, toWorld).xyz;
	

	//float4 objectPos = input.myPosition.xyzw;
	//float4 worldPos = mul(toWorld, objectPos);
	//float4 viewPos = mul(toCamera, worldPos);
	//float4 projectionPos = mul(toProjection, viewPos);

	//float4 worldPos = mul(toWorld, objectPos);
	float4 vertexViewPos = mul(toCamera, float4(newPos.xyz, 1));
	float4 vertexProjectionPos = mul(toProjection, vertexViewPos);
	result.myPosition.xyz = vertexProjectionPos.xyz;

	return result;
}