#include "..\Globals.hlsli"
#include "..\SkyboxShaderStructs.hlsli"

cbuffer ObjectBuffer : register(b1)
{
    float4x4 toWorld;
}

VertexToPixel main(VertexInput input)
{
	float4 objectPos = input.myPosition;
    float4 worldPos = mul(toWorld, objectPos);
	float4 viewPos = mul(toCamera, worldPos);
    float4 projectionPos = mul(toProjection, viewPos);

	VertexToPixel output;
    output.myPosition = projectionPos.xyww;
    output.myUV = normalize(input.myPosition.xyz);
    return output;
}