#include "..\Globals.hlsli"
#include "..\TextScreenShaderStructs.hlsli"

VertexToGeometry main(VertexInput input)
{
    float2 size = input.mySize;
    float c = cos(myRotation);
    float s = sin(myRotation);
    float3x3 transform = float3x3(
    size.x, 0, 0,
    0, size.y, 0,
    0, 0, 1
    );
    float3x3 rot = float3x3(
     c, s, 0,
    -s, c, 0,
     0, 0, 1
    );
    transform = mul(transform, rot);

    VertexToGeometry output;
    output.myTransformMatrix = transform;
    output.myPosition = input.myPosition.xyz;
    output.myUV = input.myUV;
    return output;
}